<template>
  <div id="app">

      <FormCentered>
        <template v-slot:rightContent>
          <AppInput
            inputType="text"
            :value="text"
            @input="text = $event"
          />
        </template>
      </FormCentered>
      <FormCentered>
        <template v-slot:leftContent>
          <label for="font">font</label>
        </template>
        <template v-slot:rightContent>
          <AppDatalist
            :datalist="fonts"
            :value="font"
            @input="font = $event"
          />
        </template>
      </FormCentered>
      <FormCentered>
        <template v-slot:leftContent>
          <label for="text-size">text size</label>
        </template>
        <template v-slot:rightContent>
          <AppInput
            inputType="number"
            :value="size"
            @input="size = $event"
          />
        </template>
      </FormCentered>
     <!--  <FormCentered>
        <template v-slot:leftContent>
          <label for="foreground-color">foreground color</label>
        </template>
        <template v-slot:rightContent>
          <AppInput
             inputType="color"
            :value="foregroundColor"
            @input="foregroundColor = $event"
          />
        </template>
      </FormCentered>
      <FormCentered>
        <template v-slot:leftContent>
          <label></label>
        </template>
        <template v-slot:rightContent>

        </template>
      </FormCentered>
      <FormCentered>
        <template v-slot:leftContent>
          <label for="background-color">background color</label>
        </template>
        <template v-slot:rightContent>
          <AppInput
            inputType="color"
            :value="backgroundColor"
            @input="backgroundColor = $event"
          />
        </template>
      </FormCentered> -->
      <!-- <FormCentered>
        <template v-slot:leftContent>
          <label for="height">height</label>
        </template>
        <template v-slot:rightContent>
          <AppInput
            inputType="number"
            :value="height"
            @input="height = $event"
          />
        </template>
      </FormCentered>
      <FormCentered>
        <template v-slot:leftContent>
          <label for="width">width</label>
        </template>
        <template v-slot:rightContent>
          <AppInput
            inputType="number"
            :value="width"
            @input="width = $event"
          />
         </template>
      </FormCentered> -->
      <!--  <FormCentered>
        <template v-slot:leftContent>
          <label for="transparent">transparent</label>
        </template>
        <template v-slot:rightContent>
          <AppInput
            inputType="checkbox"
            :value="isTransparent"
            @change="isTransparent = $event"
          />
        </template>
      </FormCentered> -->
      <!-- <FormCentered>
        <template v-slot:rightContent>
          <AppAnchor
            :href="dataURL"
            download="image.png"
            text="download"
          />
        </template>
      </FormCentered> -->
      <AppCanvas
        :height="parseInt(height)"
        :width="parseInt(width)"
        :foregroundColor="foregroundColor"
        :backgroundColor="backgroundColor"
        :text="text"
        :size="parseInt(size)"
        :font="font"
        :baseline="baseline"
        :angle="parseInt(angle)"
        :isTransparent="isTransparent"
        v-on:updated="updateDataURL($event)"
      />



  </div>
</template>
<style>
@import url('https://fonts.googleapis.com/css2?family=Grenze+Gotisch:wght@100;200&family=Red+Rose:wght@300;400;700&display=swap');



canvas{
  width: 100%;
}

</style>
<script>
import AppAnchor from './preview/AppAnchor'
import AppButton from './preview/AppButton'
import AppCanvas from './preview/AppCanvas'
import AppDatalist from './preview/AppDatalist'
// import AppHeader from './preview/AppHeader'
import AppInput from './preview/AppInput'
import AppSelect from './preview/AppSelect'
import FormCentered from './preview/FormCentered'
// import {version} from '../package.json'

const FONTS = [
  'arial',
  'verdana',
  'tahoma',
  'georgia',
  'times new roman',
  'courier new',
  'andale mono'
]


const BASELINES = [
  {
    id: 1,
    name: 'top'
  },
  {
    id: 2,
    name: 'hanging'
  },
  {
    id: 3,
    name: 'middle'
  },
  {
    id: 4,
    name: 'alphabetic'
  },
  {
    id: 5,
    name: 'ideographic'
  },
  {
    id: 6,
    name: 'bottom'
  }
]


const SIZE_PRESETS = [
  {
    id: 1,
    name: 'favicon (32 x 32)',
    height: 32,
    width: 32
  },
  {
    id: 2,
    name: '128 x 128',
    height: 128,
    width: 128
  },
  {
    id: 3,
    name: '256 x 256',
    height: 96,
    width: 800
  }
]

export default {
  name: 'app',
  components: {
    AppAnchor,
    AppButton,
    AppCanvas,
    AppDatalist,
    // AppHeader,
    AppInput,
    AppSelect,
    FormCentered
  },
  data () {
    return {
      text: 'The quick brown fox jumps over the lazy dog',
      size: 38,
      font: 'quiko',
      baseline: 'middle',
      foregroundColor: '#000000',
      backgroundColor: '#ffffff',
      height: 90,
      width: 800,
      angle: 0,
      fonts: FONTS,
      isTransparent: false,
      dataURL: '',
      selectedSizeId: null,
      sizeList: SIZE_PRESETS,
    }
  },
  methods: {
    updateDataURL: function (dataURL) {
      this.dataURL = dataURL
    },
    updateSize: function (sizeId) {
      if (0 < sizeId) {
        let size = this.sizeList.find(x => x.id === parseInt(sizeId))
        this.width = size.width
        this.height = size.height
      }
    },
    updateBaseline: function (id) {
      if (0 < id) {
        this.baseline = this.baselineList.find(x => x.id === parseInt(id)).name
      }
    }
  },
  beforeCreate() {
    // alert('before hook has been called');
  },
    mounted() {
       // alert('mounted hook has been called');

      // this.updateDataURL('font');
    },
    updated() {
       // alert('updated hook has been called');
    }
}
</script>


